﻿using RimWorld;
using RimWorld.Planet;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;
using Verse;
using VFECore.Abilities;
using Ability = VFECore.Abilities.Ability;

namespace OutlandMotz
{
    public class Ability_FleetingMovement : Ability
    {
        public override void Cast(params GlobalTargetInfo[] targets)
        {
            base.Cast(targets);
            this.CastEffects(targets);
            LongEventHandler.QueueLongEvent(() =>
            {
                Map map = this.pawn.Map;
                AbilityPawnFlyer flyer = (AbilityPawnFlyer)PawnFlyer.MakeFlyer(MotzDefOf.Outland_AbilityFlyer_FleetingMovement, this.pawn, targets.First().Cell);
                flyer.ability = this;
                flyer.target = targets.First().Cell.ToVector3() + new Vector3(0f, 0f, 0f);
                GenSpawn.Spawn(flyer, targets.First().Cell, map);
            }, "fleetingMovementAbility", false, null);
        }

        public override bool CanHitTarget(LocalTargetInfo target, bool sightCheck) => base.CanHitTarget(target, false);

        public override bool CanHitTarget(LocalTargetInfo target) => base.CanHitTarget(target) && target.Cell.Walkable(this.Caster.Map);
    }
}
