﻿using RimWorld;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;
using Verse;

using HarmonyLib;
using System.IO;
using System.Reflection;
using RimWorld.Planet;

namespace OutlandMotz
{
    public class MotzMod : Mod
    {
        public static MotzMod mod;
        public static MotzSettings settings;

        internal static string VersionDir => Path.Combine(ModLister.GetActiveModWithIdentifier("Neronix17.Outland.MotzCoalition").RootDir.FullName, "Version.txt");
        public static string CurrentVersion { get; private set; }

        public MotzMod(ModContentPack content) : base(content)
        {
            mod = this;
            settings = GetSettings<MotzSettings>();

            Version version = Assembly.GetExecutingAssembly().GetName().Version;
            CurrentVersion = $"{version.Major}.{version.Minor}.{version.Build}";

            new Harmony("Neronix17.Outland.MotzCoalition").PatchAll();
            LogUtil.LogMessage($"{CurrentVersion} ::");

            File.WriteAllText(VersionDir, CurrentVersion);
        }

        public override string SettingsCategory() => "Outland - Motz Coalition";

        public override void DoSettingsWindowContents(Rect inRect)
        {
            base.DoSettingsWindowContents(inRect);
        }
    }
}
