﻿using RimWorld;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;
using Verse;

namespace OutlandMotz
{
    public class ThoughtWorker_IsTooBrightForMotz : ThoughtWorker
	{
		public override ThoughtState CurrentStateInternal(Pawn p)
		{
			if(p.def != MotzDefOf.Outland_Motz)
            {
				return false;
            }
			if (!p.IsColonist)
			{
				return false;
			}
			if (DarklightUtility.IsDarklight(p.Map.glowGrid.VisualGlowAt(p.Position)))
			{
				return false;
			}
			float Brightness = BrightnessAt(p.Position, p.Map);
			if (Brightness > 0.9f)
			{
				return ThoughtState.ActiveAtStage(1);
			}
			if (Brightness > 0.45f)
			{
				return ThoughtState.ActiveAtStage(0);
			}
			return ThoughtState.Inactive;
		}

		public float BrightnessAt(IntVec3 position, Map map)
		{
			if (position.InBounds(map))
			{
				return map.glowGrid.GameGlowAt(position);
			}
			return 0;
		}
	}

}
